--
-- by HaCeSOFT
--
-- Datum : 1.7.2001
--
--	

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity klavesnice is
    Port ( sloupce : in std_logic_vector(3 downto 0);
           radky : out std_logic_vector(2 downto 0);
           vystup_LED1 : buffer std_logic_vector(11 downto 0);
			  reset : in std_logic;
           clk : in std_logic);
end klavesnice;

architecture kl1 of klavesnice is
signal radky1 : std_logic_vector(1 downto 0);
signal sloupce1 : std_logic_vector(1 downto 0);
signal akumulator : std_logic;
signal buf : std_logic_vector (3 downto 0); 
begin

process (clk, reset) begin

	if reset = '0' then
  		sloupce1 <= "00";
  		radky1 <= "00";
  		vystup_LED1 <= "000000000000";

 	elsif clk = '1' and clk'event then

		sloupce1 <= sloupce1 +1;
		case	sloupce1 is
			when "00" => akumulator <= sloupce (0);
   		when "01" => akumulator <= sloupce (1);
   		when "10" => akumulator <= sloupce (2);
			when "11" => akumulator <= sloupce (3);
			when others => NULL;
		end case;

		buf (3 downto 2) <= radky1;
 	   buf (1 downto 0) <= sloupce1; 

		case	buf is
			when	"0000" => vystup_LED1 (0) <= not akumulator;
			when	"0001" => vystup_LED1 (1) <= not akumulator;
			when	"0010" => vystup_LED1 (2) <= not akumulator;
			when	"0011" => vystup_LED1 (3) <= not akumulator;
			when	"0100" => vystup_LED1 (4) <= not akumulator;
			when	"0101" => vystup_LED1 (5) <= not akumulator;
			when	"0110" => vystup_LED1 (6) <= not akumulator;
			when	"0111" => vystup_LED1 (7) <= not akumulator;
			when	"1000" => vystup_LED1 (8) <= not akumulator;
			when	"1001" => vystup_LED1 (9) <= not akumulator;
			when	"1010" => vystup_LED1 (10) <= not akumulator;
			when	"1011" => vystup_LED1 (11) <= not akumulator;
			when others => NULL;
		end case;

		if sloupce1 = "11" then
  		radky1 <= radky1 + 1;
			if	radky1 = "10" then radky1 <= "00"; end if;
		case radky1 is
   		when "00" => radky <= "110";
   		when "01" => radky <= "101";
   		when "10" => radky <= "011";
			when others => NULL;
		end case;
		end if;
	end if;
end process;	  	
end kl1;

