--
-- by HaCeSOFT
--
-- Datum : 7.5.2001
--
--	
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Vstupni_modul1 is
    Port (BCD : in std_logic_vector(4 downto 0); 
	 		-- 4. byt BCD zbernice je obsluha Desetine Tecky !!!
	       bcd1_out : out std_logic_vector(19 downto 0);
			 reset : in std_logic;
			 clk_e : in std_logic;
          adresa : in std_logic_vector(1 downto 0));
end Vstupni_modul1;

architecture Vstupni_modul1_1 of Vstupni_modul1 is
begin
process (clk_e, reset) begin
	if reset = '0' then
	bcd1_out <= "11111111111111111111";
	elsif clk_e = '1' and clk_e'event then
 		if adresa ="00" then bcd1_out (4 downto 0) <= BCD;
 			elsif adresa ="01" then bcd1_out (9 downto 5) <= BCD;
  			elsif adresa ="10" then bcd1_out (14 downto 10) <= BCD;
			elsif adresa ="11" then bcd1_out (19 downto 15) <= BCD;
		end if;
  	end if;
end process;
end Vstupni_modul1_1;
