--
-- by HaCeSOFT
--
-- Datum : 17.9.2001
--
--	
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY DISPLAY IS
  PORT (clk : IN  STD_LOGIC;
        reset : IN  STD_LOGIC;
		  clk_e	: in std_logic;
		  DT : out std_logic;
        adresa : in std_logic_vector(1 downto 0);
        S : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
        Q : OUT STD_LOGIC_VECTOR(6 DOWNTO 0);
        BCD : IN STD_LOGIC_VECTOR(4 DOWNTO 0));
END DISPLAY;

ARCHITECTURE structural OF DISPLAY IS
COMPONENT scitat_multiplex
 PORT(clk : in std_logic;
		reset : in std_logic;
		DT : out std_logic;
 	   bcd1_in : in std_logic_vector(19 downto 0);
	   Q : out std_logic_vector(6 downto 0);
		S : OUT std_logic_vector(3 downto 0));
END COMPONENT;


COMPONENT vstupni_modul1
 PORT(BCD : in std_logic_vector(4 downto 0);
      bcd1_out : out std_logic_vector(19 downto 0);
		reset : in std_logic;
		clk_e	: in std_logic;
		adresa : in std_logic_vector(1 downto 0));
END COMPONENT;

signal bcd1_x : std_logic_vector(19 downto 0);

begin

Scitac: scitat_multiplex PORT MAP(
		clk => clk,
		DT => DT,
		reset => reset,
		bcd1_in => bcd1_x,
		Q => Q,
		S => S);

Inst_vstupni_modul1: vstupni_modul1 PORT MAP(
		BCD => BCD,
		bcd1_out => bcd1_x,
		reset => reset,
		clk_e => clk_e,
		adresa => adresa);

END structural;
